/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 3, 2004, 3:07:00 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.util.parser;

import isac.kestore.KEStoreServices;
import isac.util.Formalization;
import isac.util.parser.FormalizationDigest;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author Walther Neuper Sep 3, 2004, 3:07:00 PM
 */
public class TestFormalizationDigest extends TestCase {

	/**
	 * parse the formalization of the 'minisubpbl' example
	 * 
	 * @see isac.util.parser.TestSMLParserDigest
	 */
	public void testParseExplMini() throws IOException {
		System.out.println("---BEGIN isac.util.parser.TestFormalizationDigest");

		Vector vecA = null, vec = null;
		Formalization fmz = null, test = null;

		File fAbroad = new File("isac/src/java-tests/isac/kestore/data/exp",
				"exp_IsacCore_Tests_1b.Vector");
		File f = new File("isac/src/java-tests/isac/util/parser/data",
				"exp_IsacCore_Tests_1b.Vector");
		try {
			ObjectInputStream oisA = new ObjectInputStream(new FileInputStream(
					fAbroad));
			ObjectInputStream ois = new ObjectInputStream(
					new FileInputStream(f));
			vecA = (Vector) oisA.readObject();
			vec = (Vector) ois.readObject();
			oisA.close();
			ois.close();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		assertEquals("'Abroad' file from kestore ", vecA, vec);

		String xmlstr = (String) vec.firstElement();
		FormalizationDigest fd = new FormalizationDigest();
		fmz = fd.parseFormalization((String) xmlstr);

		f = new File("isac/src/java-tests/isac/util/parser/data",
				"exp_IsacCore_Tests_1b.fmz");
		// exp_IsacCore_Tests_1b.fmz created this way, JUST DECOMMENT AGAIN
		// try {
		//		ObjectOutputStream oos =
		//			new ObjectOutputStream(newFileOutputStream(f));
		//		oos.writeObject(fmz);
		//		oos.close();
		//	} catch (IOException e) {
		//		e.printStackTrace();
		//	}
		//--------------------------------------- JUST DECOMMENT AGAIN

		try {
			ObjectInputStream ois = new ObjectInputStream(
					new FileInputStream(f));
			test = (Formalization) ois.readObject();
			ois.close();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		System.out.println("test = " + test);
		System.out.println("test.toString() = " + test.toString());
		System.out.println("test.toString().length() = "
				+ test.toString().length());
		System.out.println("fmz.toString().length() = "
				+ fmz.toString().length());
		String s1 = test.toString();
		String s2 = fmz.toString();
		char c1, c2;
		for (int i = 0; i < s1.length(); i++) {
			c1 = s1.charAt(i);
			c2 = s2.charAt(i);
			if (c1 == c2) {
				System.out.println("equal " + c1 + ' ' + ' ' + c2);
			} else {
				System.out.println("Unequ " + c1 + ' ' + ' ' + c2);
			}

		}
		assertEquals("FormalizationDigest.parseFormalization: xmlstr --> fmz",
				test.toString(), fmz.toString());
	}


}