/*
 * Created on Aug 21, 2003 
 */
package isac.bridge;

/**
 * Simple Logging utility class used by the bridge components
 * @version 1.0
 * @author rgradisc
 */

import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;

public class BridgeLogger {
  //The logging text will be stored in this file
  FileWriter generalLog;
  
  //minimum severity level of a message to be logged
  //0 == log everything
  int minLogLevel = 0; 
  
  /**
   * Create a new BridgeLogger which writes data to a file
   * @param path The path to the file which should be logged into 
   */
  public BridgeLogger(String path) {
    try {
      generalLog = new FileWriter(path + "../sml/BridgeLog/general.txt");
      log(1, "--------------------------");
      log(1, "Server started on " + new Date());
      log(1, "--------------------------");
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  /**
   * Log general messages of bridge components in one file
   * @param level Severity level 
   * @param msg The message to be logged
   */
  public void log(int level, String msg) {
    if (level > minLogLevel) {
      try {
        generalLog.write(msg + "\n");
        generalLog.flush();
      } catch (IOException e) {
        e.printStackTrace();
      }
    }
  }

  /**
  * Close the logging file 
  */
  public void close() {
    try {
      generalLog.close();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }  
 
  public int getMinLogLevel() {
    return minLogLevel;    
  }

  public void setMinLogLevel(int i) {
    minLogLevel = i;
  }

}
