/*
 * Created on Aug 27, 2004
 */

package isac.util.formulae;

import java.io.Serializable;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.Vector;

/**
 * @author Richard Gradischnegg
 * 
 * a problemID is the key into the problem-hierarchy with the list-elements in
 * REVERSE order
 * @see <isac.util.formulae.MethodID>TODO lift several methods to
 *      CalcHeadCompoundID or drop CalcHeadCompoundID
 */
public class ProblemID extends CalcHeadCompoundID implements Serializable {

	public ProblemID() {
	}

	/**
	 * parse "[rational, univariate, equation]" to ProblemID SML-syntax woud be
	 * ["rational", "univariate", "equation"] NON-Java TODO lift to
	 * CalcHeadCompoundID or drop CalcHeadCompoundID
	 * 
	 * @see <isac.gui.calcheadviews.CalcHeadView#parseTxtProblemToStringArray>
	 */
	public ProblemID(String s) {
		int lbrace = s.indexOf("[");//regex didn't accept [
		int rbrace = s.indexOf("]");//regex didn't accept ]
		String ss;
		String[] sss;
		if ((lbrace == -1) || (rbrace == -1))
			super.id = new Vector();//TODO throw InvalidProblemIDException;
		else {
			ss = s.substring(lbrace + 1, rbrace);
			sss = ss.split(",");//"(( )*,( )*)" regex didn't accept [ ]
			if (sss[0].equals(""))
				super.id = new Vector();
			else {
				for (int i = 0; i < sss.length; i++) {
					//System.out.println("ProblemID: " + sss[i]);
					super.addString(sss[i]);
				}
			}
		}
	}

	/**
	 * returns a ProblemID as is read by SML. This is NO Java-String, e.g.
	 * ["rational", "univariate", "equation"]
	 */
	public String toSMLString() {
		StringBuffer sb = new StringBuffer();
		if (super.getID().size() > 0) {
			sb.append(" [");
			Iterator it = super.getID().iterator();
			while (it.hasNext()) {
				sb.append("\"" + it.next() + "\",");
			}
			sb.deleteCharAt(sb.length() - 1); // remove last ","
			sb.append("]");
		} else {
			sb.append("[]");
		}
		return sb.toString();
	}

	/**
	 * does a ProblemID belong to a class of problems ? e.g. ProblemID
	 * [rational, univariate, equation] belongs to class [univariate, equation]
	 */
	public boolean belongsToClass(ProblemID p_class) {
		Vector this_v = this.getID();
		Vector class_v = p_class.getID();
		ListIterator this_it = this_v.listIterator(this_v.size());
		ListIterator class_it = class_v.listIterator(class_v.size());
		boolean equal = true;

		while (class_it.hasPrevious()) { // p_class is exptected shorter
			if (!this_it.hasPrevious()) {// but this may be shorter
				equal = false;
				break;
			}
			if (!class_it.previous().equals(this_it.previous())) {
				equal = false;
				break;
			}
		}
		if (equal)
			return true;
		else
			return false;
	}

}