<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:output method="html"/>

  <xsl:template match="/">
    <xsl:choose>
      <xsl:when test="//DESCRIPTION">
        <xsl:copy-of select="//DESCRIPTION/."/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="//EXPLANATIONS">
    <b>Explanations:</b>
    <xsl:copy-of select="//EXPLANATIONS/."/>
  </xsl:template>

  <xsl:template match="KEY">
    <xsl:for-each select="ID">
      <xsl:text>-></xsl:text>
      <xsl:value-of select="."/>
    </xsl:for-each>
    <hr/>
  </xsl:template>

  <xsl:template match="//DESCRIPTION">    
    <b>Description:</b>
    <xsl:copy-of select="."/>
  </xsl:template>

  <xsl:template match="GIVEN">
    <p>
    <b><xsl:text>Given:</xsl:text></b>
    <ul>
      <xsl:for-each select="MATHML/ISA">
        <li>
          <xsl:value-of select="."/>
        </li>
      </xsl:for-each>
    </ul>
  </p>
  </xsl:template>

  <xsl:template match="WHERE">
    <p>
    <b><xsl:text>Where:</xsl:text></b>
      <xsl:for-each select="MATHML/ISA">
          <xsl:value-of select="."/>
      </xsl:for-each>
    </p>
  </xsl:template>

  <xsl:template match="FIND">
    <p>
      <b><xsl:text>Find:</xsl:text></b>
      <xsl:for-each select="MATHML/ISA">
        <xsl:value-of select="."/>
      </xsl:for-each>
    </p>
  </xsl:template>

  <xsl:template match="RELATE">
    <p>
      <b><xsl:text>Relate:</xsl:text></b>
      <xsl:value-of select="."/>
    </p>
  </xsl:template>

  <xsl:template match="THEORY">
	<hr/>
    <p>
    <b><xsl:text>Theory:</xsl:text></b>
    <xsl:value-of select="."/>
  </p>
  </xsl:template>

  <xsl:template match="METHODS">
    <p>
      <b><xsl:text>Methods:</xsl:text></b>
      
        <xsl:for-each select="KEY/ID">
          <xsl:text>-></xsl:text>
          <xsl:value-of select="."/>
        </xsl:for-each>
      
    </p>
  </xsl:template>
  
  <xsl:template match="CAS">
    <p>
      <b><xsl:text>Cas:</xsl:text></b>
      <xsl:value-of select="."/>
    </p>
  </xsl:template>

  <xsl:template match="EVAL_PRECOND">
    <p>
      <b><xsl:text>Eval Precond:</xsl:text></b>
      <xsl:value-of select="."/>
    </p>
  </xsl:template>


</xsl:stylesheet>
