/*
 * Created on Dec 11, 2003
 */
package isac.util.interfaces;

// import isac.wsdialog.IUIElement;
import java.rmi.Remote;
import java.rmi.RemoteException;

import isac.wsdialog.IUserAction;

/**
 * Interface for requesting actions from the worksheet user-interface.
 * Distinction between this interface and the interface IToUser:
 * while the interface IToUser is (among other things) usered
 * to notify the worksheet from changes in the undelying structur of the calculation,
 * the IToWorksheet interface enables the dialog to change the behaviour of the gui
 * TODO: rather use events?
 * 
 * @author Alan Krempler
 *  
 */
public interface IToWorksheet extends Remote {

	/**
	 * Put the currently active formula into editing mode
	 */
	// public void editActiveFormula();
	
	/**
	 * Append a new formula below the currently active formula
	 *
	 */
	// public void appendUserFormula();
	
	/**
	 * Set the active/inactive status of a UI object
	 * 
	 * @param id	ID of a UI object
	 * @param active Desired status (true means active)
	 */
	// public void activateUIObject(int id, boolean active);
	
	public boolean doUIAction (IUserAction action) throws RemoteException;
	
}
