(* use_thy_only"../Scripts/ListG";
   use_thy_only"Scripts/ListG";
   use_thy"Scripts/ListG";

   use_thy_only"ListG";
   W.N. 8.01
   attaches identifiers to definition of listfuns,
   for storing them in list_rls

WN.29.4.03: 
*)

ListG = Real +

consts (*'nat' in List.thy replaced by 'real'*)
  length_   :: 'a list => real
  del       :: "['a list, 'a] => 'a list"
  nth_      ::  [real, 'a list] => 'a

primrec
  length_Nil_	"length_ [] = 0"     (*length: 'a list => nat*)
  length_Cons_	"length_ (x#xs) = 1 + length_ xs"
primrec
  del_base "del [] x = []"
  del_rec  "del (y#ys) x = (if x = y then ys else y#(del ys x))"

constdefs  
  list_diff :: "['a list, 'a list] => 'a list"         (* as -- bs *)
              ("(_ --/ _)" [66, 66] 65) "a -- b == foldl del a b"
  
rules 
(*primrec error:
 *** more than one non-variable in pattern in "nth_ 1 [x] = x"--*)
  nth_Nil_      "nth_ 1 (x#xs) = x"
(*nth_Cons_     "nth_ n (x#xs) = nth_ (n+ -1) xs"
  rewriter does not reach base case   ......    ;
  the condition involves another rule set (erls, eval_binop in Atools):*)
  nth_Cons_     "1 < n ==> nth_ n (x#xs) = nth_ (n+ - 1) xs"
(*primrec from Isabelle/src/HOL/List.thy -- def.twice not allowed*)
(*primrec*)
  hd_thm	"hd(x#xs) = x"
(*primrec*)
  tl_Nil	"tl([])   = []"
  tl_Cons		"tl(x#xs) = xs"
(*primrec*)
  null_Nil	"null([])   = True"
  null_Cons	"null(x#xs) = False"
(*primrec*)
  last_thm	"last(x#xs) = (if xs=[] then x else last xs)"
(*primrec*)
  butlast_Nil	"butlast []    = []"
  butlast_Cons	"butlast(x#xs) = (if xs=[] then [] else x#butlast xs)"
(*primrec*)
  mem_Nil	"x mem []     = False"
  mem_Cons	"x mem (y#ys) = (if y=x then True else x mem ys)"
(*primrec-------already named---
  "set [] = {}"
  "set (x#xs) = insert x (set xs)"
  primrec
  list_all_Nil  "list_all P [] = True"
  list_all_Cons "list_all P (x#xs) = (P(x) & list_all P xs)"
----------------*)
(*primrec*)
  map_Nil	"map f []     = []"
  map_Cons	"map f (x#xs) = f(x)#map f xs"
(*primrec*)
  append_Nil  "[]    @ys = ys"
  append_Cons "(x#xs)@ys = x#(xs@ys)"
(*primrec*)
  rev_Nil	"rev([])   = []"
  rev_Cons	"rev(x#xs) = rev(xs) @ [x]"
(*primrec*)
  filter_Nil	"filter P []     = []"
  filter_Cons	"filter P (x#xs) =(if P x then x#filter P xs else filter P xs)"
(*primrec-------already named---
  foldl_Nil  "foldl f a [] = a"
  foldl_Cons "foldl f a (x#xs) = foldl f (f a x) xs"
----------------*)
(*primrec*)
  foldr_Nil	"foldr f [] a     = a"
  foldr_Cons	"foldr f (x#xs) a = f x (foldr f xs a)"
(*primrec*)
  concat_Nil	"concat([])   = []"
  concat_Cons	"concat(x#xs) = x @ concat(xs)"
(*primrec-------already named---
  drop_Nil  "drop n [] = []"
  drop_Cons "drop n (x#xs) = (case n of 0 => x#xs | Suc(m) => drop m xs)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for n=0 / n=Suc k*)
(*primrec*)
  take_Nil  "take n [] = []"
  take_Cons "take n (x#xs) = (case n of 0 => [] | Suc(m) => x # take m xs)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for n=0 / n=Suc k*)
(*primrec*) 
  nth_Cons  "(x#xs)!n = (case n of 0 => x | (Suc k) => xs!k)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for n=0 / n=Suc k*)
(*primrec*)
 "    [][i:=v] = []"
 "(x#xs)[i:=v] = (case i of 0     => v # xs 
			  | Suc j => x # xs[j:=v])"
----------------*)
(*primrec*)
  takeWhile_Nil	"takeWhile P []     = []"
  takeWhile_Cons
  "takeWhile P (x#xs) = (if P x then x#takeWhile P xs else [])"
(*primrec*)
  dropWhile_Nil	"dropWhile P []     = []"
  dropWhile_Cons
  "dropWhile P (x#xs) = (if P x then dropWhile P xs else x#xs)"
(*primrec*)
  zip_Nil	"zip xs []     = []"
  zip_Cons	"zip xs (y#ys) =(case xs of [] => [] | z#zs =>(z,y)#zip zs ys)"
  (* Warning: simpset does not contain this definition but separate theorems 
     for xs=[] / xs=z#zs *)
(*primrec
  upt_0   "[i..0(] = []"
  upt_Suc "[i..(Suc j)(] = (if i <= j then [i..j(] @ [j] else [])"
*)
(*primrec*)
  distinct_Nil	"distinct []     = True"
  distinct_Cons	"distinct (x#xs) = (x ~: set xs & distinct xs)"
(*primrec*)
  remdups_Nil	"remdups [] = []"
  remdups_Cons	"remdups (x#xs) = \
		\(if x : set xs then remdups xs else x # remdups xs)"
(*primrec-------already named---
  replicate_0   "replicate  0      x = []"
  replicate_Suc "replicate (Suc n) x = x # replicate n x"
----------------*)

(** Lexicographic orderings on lists ...!!!**)

end
